{{                              
Master code, to send the data readed from SD, to the slaves
}}
'*************************************************************************************
'       Used pins to drive the TLC5940 ICs.
'
' P0 -> Blue Data
' P1 -> Blue Clock
'
' P2 -> XLAT
' P3 -> BLANK
' P5 -> GSClock
'
' P6 -> Green Data
' P7 -> Green Clock
'
' P8 -> Red Data
' P9 -> Red Clock
'
'*************************************************************************************
'
' Pins   P16..23 Data Bus                                                           INPUTS
' Pin    P24    ATT      Attention      (I'll recieve a dir from the Master)        INPUT
' Pin    P25    DAV      Data available (Data available from Master)                INPUT
' Pin    P26    DRD      Data readed    (Slave answer, that got the data sent)      OUTPUT

' ORDER to recieve the data: One byte Red, following by one byte GREEN, following by one byte BLUE.
' In reality this code will needs clk and xtal, because it will be in others props.
' Also need to be added the TLC5940 code.

con
     ATT  = 24
     DAV  = 25
     DRD  = 26
     SLV  = 0            ' Slave NUMBER identification.
     
var
'
   long cog
   long Stack[40]       ' Putting 20 here my card brokes his FAT file system.
   long temp1           ' Temporal variable.
   byte w               ' General purpose variable.
   long data_num        ' Data counter variable.
   long        R[384]   ' Data for R LEDs.
   long        G[384]   ' Data for G LEDs.
   long        B[384]   ' Data for B LEDs.
   
PUB Start : Success  

   Stop
   Success :=  (Cog := cognew(Sl, @Stack) + 1) ' El dato contenido en direc tiene que ser = 0  para que no mande data a los TLC

PUB Stop
{{Stop toggling process, if any.}}

  if Cog
    cogstop(Cog~ - 1)

PUB Sl

   outa[16..23]~
   outa[ATT]~
   outa[DAV]~
   outa[DRD]~~

   dira[16..23]~
   dira[ATT]~ 
   dira[DAV]~ 
   dira[DRD]~~
   
   repeat                       ' I wont use waitpeq here, this method could be safety under noise conditions.
     if ina[ATT]                ' Attention from the Master detected. Will recieve a Slave identification.
       temp1 := ina[16..23]     ' Get the slave number
       if temp1 <> SLV          ' The data is NOT for this Slave.
         next                   ' Skip and go to the repeat line.
       outa[DRD]~               ' Now confirm that I've catched the data.
       waitpeq(0,|<ATT,0)       ' wait until the Matser accept the last confirm.
       outa[DRD]~~              ' Deactivate the line.
       quit                     ' Continue.

   w := 0     
   data_num := 1

   repeat 1152                  ' I'll recieve 1152 bytes of data.
     if ina[DAV]
       temp1 := ina[16..23]     ' Get the data.
       outa[DRD]~               ' Now confirm that I've catched the data.
       waitpeq(0,|<DAV,0)       ' wait until the Matser accept the last confirm.
       outa[DRD]~~              ' Deactivate the line.
       Case w
         0: R[data_num] := temp1
         1: G[data_num] := temp1
         2: B[data_num] := temp1   
            data_num++          ' Data counter, just here to get secuencially R[n], G[n], B[n],R[n+1], G[n+1], B[n+1].....R[384], G[384], B[384]
       w++                      ' Data order counter: 0=Red, 1=Green, 2=Blue.
       if w == 3
         w := 0
       if data_num == 384       ' 384 bytes each color.
         data_num := 1
   return

